package Mengen is

   type Menge is private;
   
   GrundmengenVerschieden : exception;
   
   ElementNichtInGrundmenge : exception;

   -- Erstellt eine leere Menge auf der Grundmenge [von .. bis].
   function LeerMengeAuf (von, bis : Integer) return Menge; 

   -- Erstellt eine Kopie von M.
   function kopieVon (M : Menge) return Menge;

   -- Trgt ein neues Element E in die Menge M ein. 
   procedure Eintrag (E : Integer; M : in out Menge); 

   -- Lscht ein Element E aus der Menge M.
   procedure Loesche (E : Integer; M : in out Menge); 

   type IntArray  is array (Integer range <>) of Integer;
   
   -- Trgt alle Elemente in die Menge M ein. 
   procedure Eintragen (Elemente : IntArray; M : in out Menge);

   -- Prft, ob E in M liegt.
   function LiegtIn (E : Integer; M : Menge) return Boolean; 

   -- Prft, ob eine M leer ist.
   function IstLeer (M : Menge) return Boolean; 

   -- Bildet die Vereinigungsmenge zweier Mengen.
   function "+" (M1, M2 : Menge) return Menge; 

   -- Bildet die Schnittmenge zweier Mengen.
   function "*" (M1, M2 : Menge) return Menge;

   -- Kleinstes Element der Obermenge von M.
   function von (M : Menge) return Integer; 

   -- Grtes Element der Obermenge von M.
   function bis (M : Menge) return Integer; 
   
   -- Nimmt Elemente von M2 zu M1 hinzu.
   procedure Hinzu (M1 : in out Menge; M2 : Menge); 
 
   -- Entfernt die Elemente von M2 aus M1.
   procedure Hinweg (M1 : in out Menge; M2 : Menge);
   
   -- Druckt M.
   procedure Drucke (M : Menge);
   
private

   type Menge_Rec;
   
   type Menge is access Menge_Rec;
   
end Mengen;